#!/usr/bin/perl

use strict;
use warnings;

require './hutool.pl';
require './lib.pl';

my @GET_NAME    = ('mode','name','time','open','w');
my @POST_NAME   = ('mode','time','grade','subject','type','name','text','inin');

our %GET        = &hutool::DECODE_GET(@GET_NAME);
our %POST       = &hutool::DECODE_POST(@POST_NAME);

our $log_dir    = './log/past';
our $dis_dir    = './log/out';

our $nowfile    = sprintf('./log/now.txt');
our $logfile    = sprintf('./log/output.txt');
our $mode_file  = sprintf('./log/mode.txt');
our $list_file  = sprintf('./log/list.txt');
our $renew_file = sprintf('./log/renew.txt');

our $this       = &hutool::THIS();

print "Content-type: text/html\n\n";
print &main();

sub main
{
  my $html='';
  my $mode='d';
  my $file=$nowfile;

    if($POST{'mode'} ne ''){$mode=$POST{'mode'};}
    elsif($GET{'mode'} ne ''){$mode=$GET{'mode'};}
    if($POST{'open'} ne ''){$file=$POST{'open'};}
    elsif($GET{'open'} ne ''){$file=$GET{'open'};}
    if($POST{'time'} eq ''){$POST{'time'}=0;}
    if($GET{'time'} eq ''){$GET{'time'}=0;}

  $html.=&header($mode,$file);


#  if($POST{'name'}=~/[0-9]/)
#  {
    if(&log_write($file,$logfile))
    {
      &lib::renewal_time($renew_file);
    }else{}


    my $form='';
    foreach(&hutool::OPEN_FILE($file))
    {
      my %file;
      ($file{'time'},$file{'type'},$file{'grade'},$file{'subject'},$file{'name'},$file{'text'})=&lib::log_read($_);

      if($file{'time'} == $POST{'time'} || $file{'time'} == $GET{'time'})
      {
        if($GET{'time'}     >  0 ){$POST{'time'}=$GET{'time'};}else{$POST{'time'}=$file{'time'};}
        if($POST{'grade'}   eq ''){$POST{'grade'}  =$file{'grade'};}
        if($POST{'subject'} eq ''){$POST{'subject'}=$file{'subject'};}
        if($POST{'type'}    eq ''){$POST{'type'}   =$file{'type'};}
        if($POST{'name'}    eq ''){$POST{'name'}   =$file{'name'};}
        if($POST{'text'}    eq ''){$POST{'text'}    =$file{'text'};}
        $form=&form($file,$mode,$POST{'time'},$POST{'grade'},$POST{'subject'},$POST{'type'},$POST{'name'},$POST{'text'});
        last;
      }
    }

    if($form eq ''){$form=&form($file,$mode,'0','','','','','');}

    $html.=$form;
    if($mode ne 's'){$html.=&loglist($file,$mode);}#
    $html.='</div>';


  $html.=&footer();

  return $html;
}

sub loglist
{
  my($file,$mode)=@_;
  my @ns=('n','n');
  if($file eq $nowfile){$ns[0]='s';}
  elsif($file eq $logfile){$ns[1]='s';}

  return sprintf('<hr />
<ul class="tab">
<li class="%sl"></li>
<li class="%stitle"><a href="./%s?mode=%s&open=%s">書き込みリスト</a></li>
<li class="%sr"></li>
<li class="%sl"></li>
<li class="%stitle"><a href="./%s?mode=%s&open=%s">表示リスト</a></li>
<li class="%sr"></li>
</ul>
<div id="result"></div>'
  ,$ns[0],$ns[0],$this,$mode,$nowfile,$ns[0]
  ,$ns[1],$ns[1],$this,$mode,$logfile,$ns[1]);
}

sub log_write
{
  my($file,$nfile)=@_;
  my $resalt=0;

  #if($POST{'name'} eq '')
  #{
  #  if($POST{'type'} eq 'H')
  #  {
  #    $POST{'name'}='提出者';
  #  }elsif($POST{'type'} eq 'C')
  #  {
  #    $POST{'name'}='議長';
  #  }
  #}

  if(  ($POST{'text'} ne ''  &&
        ($POST{'subject'} eq 'h' || $POST{'subject'} eq 'G' || $POST{'type'} eq 'N' || #提出者か議長の発言かアナウンス
         ($POST{'type'} ne '' && $POST{'grade'} ne '' && $POST{'subject'} ne '' && $POST{'name'} ne '' )
        )
       )
     ||
      ($POST{'text'} eq 'W')#撤回動議
     || 
      (
       $POST{'grade'} ne '' && $POST{'subject'} ne '' &&
       ($POST{'text'} eq 'A' || $POST{'text'} eq 'R' || $POST{'text'} eq 'D')
      )
    )
  {$resalt=1;
  #ファイルへの新規、編集書き込み
    $POST{'text'}=~s/\r//g;
    $POST{'text'}=~s/\n{1,}/<br \/>/g;

#    if($POST{'type'} eq 'V'){}

    my @list=&hutool::OPEN_FILE($file);

    if($POST{'subject'} eq 'h')
    {
      $POST{'name'}='提出者';
      $POST{'subject'}='';
      $POST{'grade'}='';
      $POST{'type'}='';
    }elsif($POST{'subject'} eq 'G')
    {
      $POST{'name'}='議長';
      $POST{'subject'}='';
      $POST{'grade'}='';
      $POST{'type'}='';
    }

    my $newdata='';
    if($POST{'time'} == 0){$newdata=join("\t",time(),$POST{'type'});}
    else{$newdata=join("\t",$POST{'time'},$POST{'type'});}

    if($POST{'type'} eq 'G')
    {#議案名
      $newdata='';#join("\t",$newdata,$POST{'text'});
      my @l=&lib::get_list($list_file);
      my $wm='G';
      my $num=-1;
      if($l[$POST{'text'}]{'type'} eq 'S' || $l[$POST{'text'}]{'type'} eq 'E'){$wm=$l[$POST{'text'}]{'type'};}

      my %GM=&lib::get_mode($mode_file);
      my %lst;

      foreach(@l)
      {
        %lst=%$_;
        if($lst{'bill'} eq $GM{'bill'})
        {
          $num=$lst{'number'};
          last;
        }
      }

      my $log_f=&lib::logfile_name($log_dir,$num);
#$l[$POST{'text'}]{'name'}=~s/\s/_/i;
      &lib::out_mode($mode_file,$wm,$l[$POST{'text'}]{'bill'},$l[$POST{'text'}]{'name'},
                     $l[$POST{'text'}]{'grade'}.$l[$POST{'text'}]{'subject'},$l[$POST{'text'}]{'type'});

      if(open(LOG,">$log_f"))
      {
        print LOG reverse(@list);
        close(LOG);

        my $out_f=0;
        while(-f "$dis_dir/$out_f\.txt"){++$out_f;}
        $out_f="$dis_dir/$out_f\.txt";
        if(open(OUTL,">$out_f"))
        {
          print OUTL reverse(&hutool::OPEN_FILE($logfile));
          close(OUTL);
        }
        @list=();
        $newdata='';
      }

    }elsif($POST{'type'} eq 'W')
    {#撤回動議
      #$newdata=join("\t",$newdata,$POST{'type'});  
    }elsif($POST{'type'} eq 'N')
    {#アナウンス
      $newdata=join("\t",$newdata,$POST{'text'});      
    }elsif($POST{'type'} eq 'V')# || $POST{'type'} eq 'A' || $POST{'type'} eq 'R' || $POST{'type'} eq 'D'
    {#その他採決系のある動議など
      $POST{'grade'  }=&lib::wide2half($POST{'grade'});
      $POST{'subject'}=&lib::wide2half($POST{'subject'});
      $POST{'name'   }=&lib::wide2half($POST{'name'});
      $POST{'inin'   }=&lib::wide2half($POST{'inin'});
      $newdata=join("\t",$newdata,$POST{'text'},$POST{'grade'},$POST{'subject'},$POST{'name'},$POST{'inin'});
    }else
    {
      $newdata=join("\t",$newdata,$POST{'grade'},$POST{'subject'},$POST{'name'},$POST{'text'});
    }

    if($newdata ne '')
    {
      if($POST{'time'} == 0)
      {
        unshift(@list,"$newdata\n");
      }else
      {
        my $stime=$POST{'time'};
        foreach(@list)
        {
          if($_=~/^$stime/)
          {
            $_="$newdata\n";
            last;
          }
        }
      }
    }

    if(-f $file && open(LOG,">$file"))
    {
      print LOG @list;
      close(LOG);

      if(scalar(@list)<=0 && -f $nfile && open(NLOG,">$nfile"))
      {
        close(NLOG);
      }
    }


  }elsif($GET{'open'} ne '' && $GET{'time'} =~/[^\D]/ && $GET{'w'} ne '')
  {
    $resalt=1;

    if($GET{'w'} == 1)
    {#書き込み
      my $newdata='';
      my @list=&hutool::OPEN_FILE($file);

      foreach(@list)
      {
        my($time,$type,$grade,$subject,$name,$txt)=&lib::log_read($_);
        if($time == $GET{'time'})
        {
          $newdata=$_;
          my $ntime=time();
          $newdata=~s/^([0-9]+)/$ntime/;
          last;
        }
      }

      if($newdata ne '')
      {
        @list=&hutool::OPEN_FILE($logfile);
        unshift(@list,"$newdata\n");
        my $line=join('',@list);
        $line=~s/(\n)+/\n/g;
        if( open(OUT,">$logfile") )
        {
          print OUT $line;
          close(OUT);
        }else{$resalt=0;}
      }
    }elsif($GET{'open'} eq $logfile)
    {#削除
      my @list=&hutool::OPEN_FILE($logfile);

      foreach(@list)
      {
        my($time,$type,$grade,$subject,$name,$txt)=&lib::log_read($_);
        if($time == $GET{'time'})
        {
          $_='';
          last;
        }
      }
      my $line=join('',@list);
      $line=~s/(\n)+/\n/g;
      if( open(OUT,">$logfile") )
      {
        print OUT $line;
        close(OUT);
      }else{$resalt=0;}

    }

  }else
  {
    $resalt=0;
  }

  if($resalt==1){
    $POST{'grade'}=$POST{'subject'}=$POST{'type'}=$POST{'name'}=$POST{'text'}='';
  }

  return $resalt;
}

sub form
{
  my ($file,$mode,$time,$GRADE,$SUBJECT,$TYPE,$NAME,$TEXT)=@_;
  my $html='';
  my $n;
  my $s;
  my @tmp;

  my ($mmode,$mbill,$mname,$mgs,$mtype)=split(/[\t|\n]/,join('',&hutool::OPEN_FILE($mode_file)) );

  if($mode eq 'd')
  {
    $html.=sprintf('
 <div class="block" style="position:absolute;left:0px;">
  <div class="name"><span id="ptype"></span> <span id="pgrade"></span><span id="psubject"></span><br /><span id="pname"></span></div>
  <div class="text"><span id="ptext"></span></div>
 </div>');
  }elsif($mode eq 'v')
  {
    if($mtype eq 'V')
    {
      $html.=sprintf('
 <div class="block" style="position:absolute;left:0px;">
  <div class="name"><br /></div>
  <div class="text">
<div><span id="pgrade"></span><span id="psubject"></span><span id="pname"></span></div>
<div style="margin:0px 0px 0px 2px;color:#FFD899;">　信任票数：<span class="hw" id="for"></span><span id="ifor"></span>票</div>
<div style="margin:0px 2px 0px 0px;color:#11DDFF;">　不信任票数：<span class="hw" id="against"></span><span id="iagainst"></span>票</div>
<span id="vresult"></span>
  </div>
 </div>');
    }else
    {
      $html.=sprintf('
 <div class="block" style="position:absolute;left:0px;">
  <div class="name"><span id="pgrade"></span><span id="psubject"></span><br /><span id="pname"></span></div>
  <div class="text"><span id="ptext">
<div style="margin:0px 0px 0px 2px;color:#FFD899;">　賛成票数：<span class="hw" id="for"></span><span id="ifor"></span>票</div>
<div style="margin:0px 2px 0px 0px;color:#11DDFF;">　反対票数：<span class="hw" id="against"></span><span id="iagainst"></span>票</div>
<span id="vresult"></span>
</span></div>
 </div>');
    }

  }
  my @ns=('n','n','n');
  if($mode eq 's'){$ns[0]='s';}
  elsif($mode eq 'd'){$ns[1]='s';}
  elsif($mode eq 'v'){$ns[2]='s';}
  $html.=sprintf('<div style="position:absolute;left:165px;">
<ul class="tab">
<li class="%sl"></li>
<li class="%stitle"><a href="./%s?mode=s">審議開始</a></li>
<li class="%sr"></li>
<li class="%sl"></li>
<li class="%stitle"><a href="./%s?mode=d">審議中</a></li>
<li class="%sr"></li>
<li class="%sl"></li>
<li class="%stitle"><a href="./%s?mode=v">動議・採決</a></li>
<li class="%sr"></li>
</ul>'
  ,$ns[0],$ns[0],$this,$ns[0]
  ,$ns[1],$ns[1],$this,$ns[1]
  ,$ns[2],$ns[2],$this,$ns[2]);


  $html.=sprintf('<br style="clear:left;" /><form action="./%s" method="POST" name="input">%s',$this,"\n");
  $html.=sprintf('<input name="mode" type="hidden" value="%s" id="mode" />%s',$mode,"\n");
  $html.=sprintf('<input name="open" type="hidden" value="%s"/>%s',$file,"\n");
  $html.=sprintf('<input name="time" type="hidden" value="%d"/>%s',$time,"\n");

  if($mode eq 'd')
  {

    $html.=sprintf('
<p><b>説明！！</b><br />
このページは、普段の発言を入力するためのページです。<br />
個人情報は、学年、学科の場合は選択し、名前はひらがなは自動でカタカナになるので、打ち込んだらすぐに確定してください。<br />
発言情報は、何の発言かは選択で、その内容は書き込み形式となっています。<br />
発言は大体の概要程度に抑え、あまり長文にしないでください。</p>
');

#GRADE PART
    $html.=sprintf('学年:%s',"\n");
    if($GRADE eq ''){$GRADE=0;}
    for($n=1;$n<=4;++$n)
    {
      if($n==$GRADE){$s=' checked="checked"'}else{$s='';}
      #if($n==1){
#$s.=' name="f"';#}
      push(@tmp,sprintf('<span id="box"><input name="grade" id="grade" type="radio" value="%s" onclick="print_rg(%d);"%s />%s</span>',$n,$n,$s,$n));
    }
    $html.=join(",\n",@tmp);

    $html.="<br />\n";

#SUBJECT PART
    $html.=sprintf('学科:%s',"\n");
#要らない配列。後でセッティングから読み込むように
    my @SUBJECTS=('C','J','E','M','F','T','H');
    foreach(@SUBJECTS)
    {
      if($SUBJECT eq $_){$s=' checked="checked"'}else{$s='';}
      $_=sprintf('<span id="box"><input name="subject" id="subject" type="radio" value="%s" onclick="print_rs(\'%s\');"%s />%s</span>',$_,$_,$s,$_);
    }

    $html.=join(",\n",@SUBJECTS);
    if($SUBJECT eq 'h' || $NAME eq '提出者'){$s=' checked="checked"';$NAME='';}else{$s='';}
    $html.=sprintf(',%s<span id="box"><input name="subject" id="subject" type="radio" value="%s" onclick="print_rs(\'h\');"%s />%s</span>',"\n",'h',$s,'提出者');
    if($SUBJECT eq 'G' || $NAME eq '議長'){$s=' checked="checked"';$NAME='';}else{$s='';}
    $html.=sprintf(',%s<span id="box"><input name="subject" id="subject" type="radio" value="%s" onclick="print_rs(\'G\');"%s />%s</span>',"\n",'G',$s,'議長');

    $html.="<br />\n";

#NAME PART
    $html.=sprintf('名前:<input name="name" type="text" id="name" size="20" value="%s" /><br />%s',$NAME,"\n");


#TYPE PART
    $html.=sprintf('発言:%s',"\n");
    @tmp=('質問','回答','意見','その他',
          'Q','A','S','O');
    for($n=0;$n<=3;++$n)
    {
      if($TYPE eq $tmp[$n+4]){$s=' checked="checked"'}else{$s='';}
      $tmp[$n]=sprintf('<span id="box"><input name="type" type="radio" value="%s"%s onclick="print_rt(\'%s\');" />%s</span>',$tmp[$n+4],$s,$tmp[$n],$tmp[$n]);
    }
    $html.=join(",\n",@tmp[0..3]);
    if($TYPE eq 'N'){$s=' checked="checked"';$TEXT=$GRADE;}else{$s='';}
    $html.=sprintf('<span id="box"><input name="type" type="radio" value="N"%s />アナウンス</span>',$s);
    $html.="<br />\n";


#TEXT PART
    $TEXT=~s/<br \/>/\n/g;
    $html.=sprintf('文章:<textarea name="text" id="text" cols="43" rows="4">%s</textarea><br />%s',$TEXT,"\n");

#SUBMIT BUTTOM
    $html.=sprintf('<input type="submit" value="書き込み">%s',"\n");

  }elsif($mode eq 's')
  {
    $html.=sprintf('
<p><b>説明！！</b><br />
このページは、議案名を入力するためのページです。<br />
それ以外にも、公聴会、総会を終えてからや開始前、終了後の特別ページを表示する際にも使います。
</p>
'   );

#GRADE PART
    $html.=sprintf('<input name="grade" type="hidden" value="0" />%s',"\n");
#SUBJECT PART
    $html.=sprintf('<input name="subject" type="hidden" value="0" />%s',"\n");
#TYPE PART
    $html.=sprintf('<input name="type" type="hidden" value="G" />%s',"\n");

#TEXT PART
  #$html.=sprintf('議案名:<input type="text" name="text" value="%s"><br />議案名を書いてください。<br />%s',$TEXT,"\n");

#NAME PART
    $html.=sprintf('<input name="name" type="hidden" value="0" />%s',"\n");

    $html.=sprintf('<select name="text">');
    my %GM=&lib::get_mode($mode_file);
    foreach(&lib::get_list($list_file))
    {
      if(ref($_) eq 'HASH')
      {
        my %list=%$_;
        if(!($list{'number'}=~/[\D]/) && $list{'bill'} ne '' && $list{'name'} ne '' && $list{'grade'} ne '' && $list{'subject'} ne '')
        {
          my $s='';
          if($list{'bill'} eq $GM{'bill'}){$s=' selected="selected"';}
          if( $list{'type'} ne 'G' && $list{'type'} ne 'O')
          {
            $html.=sprintf('<option value="%d"%s>%s</option>',
                           $list{'number'},$s,$list{'bill'});
          }else
          {
            $html.=sprintf('<option value="%d"%s>%s : %d%s%s</option>',
                           $list{'number'},$s,$list{'bill'},$list{'grade'},$list{'subject'},$list{'name'});
          }
        }else{}
      }
    }
    $html.=sprintf('</select>');


    #$html.=sprintf('提出者:<input name="name" type="text" /><br />提出者を書いてください。<br />%s',"\n");

#SUBMIT BUTTOM
    $html.=sprintf('<input type="submit" value="審議開始">%s',"\n");

  }elsif($mode eq 'v')
  {
    $html.=sprintf('
<p><b>説明！！</b><br />
このページは、動議や採決の結果を入力するためのページです。<br />
採決もしくは動議を選択し、賛成票、反対票、議長委任表を入力すれば、計算や結果を自動的に整形して出力します。<br />
</p>
');
#TYPE PART
    $html.=sprintf('<input name="type" type="hidden" value="V" />%s',"\n");
#TEXT PART
    $html.=sprintf('発言:%s',"\n");
    @tmp=('採決','休会動議','保留動議','採決要求動議','撤回動議',
          'V','A','R','D','W');

#    my ($mmode,$mbill,$mname,$mgs,$mtype)=split(/[\t|\n]/,join('',&hutool::OPEN_FILE($mode_file)) );

    if($mtype eq 'V')
    {
      if($TEXT eq 'L'){$s=' checked="checked"'}else{$s='';}
      $html.=sprintf('<span id="box"><input name="text" type="radio" value="L" onclick="print_rs(\'%s\');"%s />委員長</span>','委員長',$s);
      if($TEXT eq 'l'){$s=' checked="checked"'}else{$s='';}
      $html.=sprintf('<span id="box"><input name="text" type="radio" value="l" onclick="print_rs(\'%s\');"%s />副委員長</span>','副委員長',$s);
    }else
    {
      for($n=0;$n<=4;++$n)
      {
        if($TEXT eq $tmp[$n+5]){$s=' checked="checked"'}else{$s='';}
        $tmp[$n]=sprintf('<span id="box"><input name="text" type="radio" value="%s" onclick="print_rs(\'%s\');"%s />%s</span>',$tmp[$n+5],$tmp[$n],$s,$tmp[$n]);
      }
      $html.=join(",\n",@tmp[0..4]);
    }

    $html.="<br />\n";

#NAME PART
    if($mtype eq 'V')
    {#選挙
#      $html.=sprintf('名前<input name="name" type="text" value="%s" />%s',$NAME,"\n");
      $html.=sprintf('<select name="name">');
      foreach(split(/,/,$mname))
      {
        if($_=~/[\S]/)
        {
          my $n=$_;
          $n=~s/_/ /g;
          $html.=sprintf('<option value="%s">%s</option>',$n,$n);
        }
      }
      $html.=sprintf('</select>');
      $html.=sprintf('委任状<input type="text" name="inin" value="%s" id="inin" /><br />',$POST{'inin'});
      $html.='<br />';
#GRADE PART
      $html.=sprintf('信任<input name="grade" type="text" value="%s" id="grade" />票%s',$GRADE,"\n");
#SUBJECT PART
      $html.=sprintf('不信任<input name="subject" type="text" value="%s" id="subject" />票%s',$SUBJECT,"\n");
    }else
    {#議案
      $html.=sprintf('議長委任<input name="name" type="text" value="%s" id="inin" />票%s',$NAME,"\n");
      $html.='<br />';
#GRADE PART
      $html.=sprintf('賛成<input name="grade" type="text" value="%s" id="grade" />票%s',$GRADE,"\n");
#SUBJECT PART
      $html.=sprintf('反対<input name="subject" type="text" value="%s" id="subject" />票%s',$SUBJECT,"\n");
    }


    $html.="<br />\n";

#SUBMIT BUTTOM
    $html.=sprintf('<input type="submit" value="決定">%s',"\n");
  }

  $html.=sprintf('</form>%s',"\n");


  return $html;
}

sub list{
  my($file)=@_;
  my $html='';
  my @list=&hutool::OPEN_FILE($file);



  foreach(@list){
    $_=sprintf('<div style="border:1px solid black;">%s</div>',$_);
  }

  $html=join('',@list);

  return $html;
}

sub login{
  my ($name)=@_;
  my $html='';
  my $file=join('.',&lib::make_filename(),'txt');
#  my @list=&hutool::OPEN_FILE(&hutool::PASS_JOIN('/',$log_dir,&hutool::ENCODE($name),$file));
  my @list=&hutool::GET_FILE_LIST('directory',$log_dir);

  $html.=sprintf('<form action="./%s" method="POST">
'
  ,$this);

  foreach(@list){}

  $html.=sprintf('</form>');

  return $html;
}

sub header
{
  my($mode,$file)=@_;
  return sprintf('<html>
<head>
 <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
 <title>編集者用</title>
 <style>
  <!--
  -->
 </style>
 <script type="text/javascript" src="./http.js"></script>
 <script type="text/javascript" src="./change_words.js"></script>
 <script laguage="JavaScript">
<!--

max=3;
ct=0;

//最終更新時間
RnewalTime=0;
//通信用オブジェクト
httpObject=null;


  //画面への出力関数
  //Ajaxの非同期通信で使われる
  function log_write()
  {
    if(httpObject && (httpObject.readyState == 4) && (httpObject.status == 200) )
    {
      //IDがresultのタグで囲まれた部分をCGIの出力に書き換える。
      document.getElementById("result").innerHTML=httpObject.responseText;
    }else
    {
    }
  }

  function get_time()
  {
    var now = new Date();
    return now.getHours()*10000+now.getMinutes()*100+now.getSeconds();
  }

  function print_v()
  {
    document.input.grade.value                    = wide2half(document.input.grade.value);
    document.input.subject.value                  = wide2half(document.input.subject.value);
    document.input.name.value                     = wide2half(document.input.name.value);
    document.input.inin.value                     = wide2half(document.input.inin.value);
    if(document.getElementById("psubject").innerHTML == "採決")
    {/*採決*/
      document.getElementById("for").innerHTML      = document.input.grade.value
      document.getElementById("against").innerHTML  = document.input.subject.value;

      /*委任状*/
      if(document.input.grade.value*1>document.input.subject.value*1)
      {/*賛成多し*/
        document.getElementById("iagainst").innerHTML  = "";
        add=document.input.grade.value*1+document.input.inin.value*1;
        document.getElementById("ifor").innerHTML      = " ＋ <span class=\"hw\">"+document.input.inin.value+"</span> = <span class=\"hw\">" + add +"</span>";
        document.getElementById("vresult").innerHTML      = "◇可決◇";
      }else if(document.input.grade.value*1<document.input.subject.value*1)
      {
        document.getElementById("ifor").innerHTML      = "";
        add=document.input.subject.value*1+document.input.inin.value*1;
        document.getElementById("iagainst").innerHTML  = " ＋ <span class=\"hw\">"+document.input.inin.value+"</span> = <span class=\"hw\">" + add +"</span>";
        document.getElementById("vresult").innerHTML      = "◆否決◆";
      }else
      {
        document.getElementById("iagainst").innerHTML  = "";
        add=document.input.grade.value*1+document.input.inin.value*1;
        document.getElementById("vresult").innerHTML      = "";
      }

    }else
    {/*採決以外*/
      document.getElementById("for").innerHTML      = document.input.grade.value;
      document.getElementById("against").innerHTML  = document.input.subject.value;
      document.getElementById("ifor").innerHTML     = "";
      document.getElementById("iagainst").innerHTML = "";
      if(document.input.grade.value*1>document.input.subject.value*1)
      {/*賛成多し*/
        document.getElementById("vresult").innerHTML      = "◇可決◇";
      }else if(document.input.grade.value*1<document.input.subject.value*1)
      {
        document.getElementById("vresult").innerHTML      = "◆否決◆";
      }else
      {
        document.getElementById("vresult").innerHTML      = "";
      }
    }

  }
  function renew()
  {
    if(ct == 0)
    {
      httpObject=Http_Content("./editor_sub.cgi"+"?"+get_time()+"&mode="+"%s"+"&open="+"%s",log_write);
    }
    if(ct>=max){ct=0;}
    else{++ct;}

    document.input.name.value=hira2kata(document.input.name.value);
    if(document.input.mode.value == "d")
    {
      print_ta();
    }else if(document.input.mode.value == "v")
    {
      print_v();
    }
  }
  function print_ta()
  {
    document.input.name.value                     = hira2kata(document.input.name.value);
    //document.getElementById("text").innerHTML     = wide2half(document.getElementById("text").innerHTML);
    if(document.getElementById("pname").innerHTML != "議長" &&
       document.getElementById("pname").innerHTML != "提出者")
    {
      document.getElementById("pname").innerHTML    = document.input.name.value;
    }
    document.getElementById("ptext").innerHTML    = document.getElementById("text").innerHTML;
  }
  function print_rg(g){
    if(document.getElementById("pname").innerHTML != "議長" &&
       document.getElementById("pname").innerHTML != "提出者")
    {
      document.getElementById("pgrade").innerHTML   = g;
    }
  }
  function print_rs(s){
    if(s == "h")
    {
      print_rg("");
      document.getElementById("psubject").innerHTML="";
      //print_rs("");
      document.getElementById("pname").innerHTML  = "提出者";
    }else if(s == "G")
    {
      print_rg("");
      document.getElementById("psubject").innerHTML="";
      //print_rs("");
      document.getElementById("pname").innerHTML  = "議長";
    }else
    {
      document.getElementById("psubject").innerHTML = s;
    }
  }
  function print_rt(t){
    if(document.getElementById("pname").innerHTML != "議長" &&
       document.getElementById("pname").innerHTML != "提出者")
    {
      document.getElementById("ptype").innerHTML = t;
    }
  }

  function start()
  {
    document.getElementById("result").innerHTML="<br style=\'clear:left;\'/>Now Loding ...";
    //更新
    renew();
  }
-->
  </script>
 <link rel="icon" href="./favicon.ico" type="image/vnd.microsoft.icon" />
 <link rel="stylesheet" href="./material/style.css" type="text/css" />
</head>
<body style="overflow-x:scroll;" onLoad="start();setInterval(\'renew()\',1000)">
'  
  ,$mode,$file);
}
# style="overflow-y:hidden;"
sub footer
{
  return sprintf('</body>%s</html>%s',"\n","\n");
}
