#!/usr/bin/perl

use strict;
use warnings;

require './hutool.pl';
require './lib.pl';

my @GET_NAME    = ('mode','open');

our %GET        = &hutool::DECODE_GET(@GET_NAME);

our $log_dir    = './log/past';

our $nowfile    = sprintf('./log/now.txt');
our $logfile    = sprintf('./log/output.txt');
our $mode_file  = sprintf('./log/mode.txt');
our $list_file  = sprintf('./log/list.txt');
our $renew_file = sprintf('./log/renew.txt');

our $this       = 'editor.cgi';

print "Content-type: text/html\n\n";
print &main($GET{'open'},$GET{'mode'});

sub main
{
  my($file,$mode)=@_;

  return &loglist($file,$mode);
}

sub loglist
{
  my($file,$mode)=@_;
  my $html='';

  $html.=sprintf('<table style="clear:left;">');

  if($file ne '' && -f $file)
  {
    my @list=&hutool::OPEN_FILE($file);
    my $s='';
    my $m='';
    if($file eq $logfile)
    {
      $s='<img src="./material/bottom_d.png" />';
      $m='0';
    }else
    {
      $s='<img src="./material/bottom_w.png" />';
      $m='1';
    }
    foreach(@list)
    {
      my($time,$type,$md,@data)=&lib::log_read($_);
      my %time=&lib::now_time($time);
      my $ptime=sprintf('%02d:%02d:%02d',$time{'hour'},$time{'min'},$time{'sec'});

      if($mode eq 'v' && $type eq 'V')
      {
        my($for,$against,$inin);
        if($m eq 'V')
        {
          ($for,$against,$inin)=@data;
          if($for>$against)
          {#可決
            $for=sprintf('%d+%d=%d',$for,$inin,$for+$inin);
            $inin='可決';
          }elsif($for<$against)
          {#否決
            $against=sprintf('%d+%d=%d',$against,$inin,$against+$inin);
            $inin='否決';
          }else{$inin='未決';}
        }else
        {
          ($for,$against,$inin)=@data;
          if($for>$against)
          {#可決
            $for=sprintf('%d+%d=%d',$for,$inin,$for+$inin);
            $inin='可決';
          }elsif($for<$against)
          {#否決
            $against=sprintf('%d+%d=%d',$against,$inin,$against+$inin);
            $inin='否決';
          }else{$inin='未決';}
        }

        $html.=sprintf('<tr>
<td><a href="./%s?mode=d&open=%s&time=%d&%d"><img src="%s" /></a></td>
<td>[%s]</td>
<td>賛成:%s票 反対:%s票</td>
<td>%s</td>
<td><a href="./%s?mode=d&open=%s&time=%d&w=%s&%d">%s</a></td>
</tr>
'
        ,$this,$file,$time,time(),'./material/bottom_e.png'
        ,$inin,$for,$against,$ptime
        ,$this,$file,$time,$m,time(),$s);
      }elsif($mode eq 'd' && $type ne 'V')
      {
        my $grade=$md;
        my($subject,$name,$txt)=@data;
        my %tmp=('Q'=>'質問','A'=>'回答','S'=>'意見','H'=>'提出者','C'=>'議長','N'=>'アナウンス','O'=>'その他');
        if($type eq 'N'){$txt=$grade;$grade='';}
        $html.=sprintf('<tr>
<td><a href="./%s?mode=d&open=%s&time=%d&%d"><img src="%s" /></a></td>
<td><b>%s</b><br />%s%s%s</td>
<td>%s</td>
<td>%s</td>
<td><a href="./%s?mode=d&open=%s&time=%d&w=%s&%d">%s</a></td>
</tr>
'
        ,$this,$file,$time,time(),'./material/bottom_e.png'
        ,$tmp{$type},$grade,$subject,$name,$txt,$ptime
        ,$this,$file,$time,$m,time(),$s);
      }else{}
    }
  }

  $html.=sprintf('</table>');

  return $html;
}
