package hutool;

##############################
# 
# This library name is "hiroki's useful tool shikko edition".
# This omits and is "hutool".
# 
# Although this library is my lower part, 
# It is the medley of the processing often used.
# 
# This library can be used freely.
# It can distribute, even if there is no permission, if it is no charge.
# 
# Copyright (C) Since 2005 Hiroki (MailAddores:hirokiyami@yahoo.co.jp)
# 
##############################

sub information{
  my($VERSION)  ='S.1.0';#2009/05/21

  my($COPYRIGHT)  ='Copyright (C) From 2005 Hiroki';
}

##############################
#URL CONVERTER
##############################

sub URL_CONVERTER
{
  my(@data)=@_;

  foreach(@data)
  {
    if($_=~/[^\w\=\& ]/)
    {#encode
      $_=&hutool::ENCODE($_);
    }else
    {#decode
      $_=&hutool::DECODE($_);
    }
  }
  return @data;
}

sub DECODE
{
  my(@decode)=@_;
  foreach(@decode)
  {
    $_=~ s/\+/ /g;
    $_=~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
  }
  if($#decode==0)
  {
    return $decode[0];
  }else
  {
    return @decode;
  }
}

sub ENCODE
{
  my(@encode)=@_;
  foreach(@encode)
  {
    $_=~ s/([^\w\=\& ])/'%'.unpack("H2", $1)/eg;
    $_=~ tr/ /+/;
  }
  if($#encode==0)
  {
    return $encode[0];
  }else
  {
    return @encode;
  }
}

##############################
#THIS FILE NAME
##############################
sub THIS
{
  my(@return);
  if($_[0] eq "")
  {
    my(@name)=split(/\//,$ENV{"SCRIPT_NAME"});
    return pop(@name);
  }else
  {
    my(@name);
    foreach (@_)
    {
      @name=split(/\//,$_);
      push(@return,pop(@name));
    }
    return @return;
  }
}

##############################
#TEXT ADDREVIATION
##############################
sub TEXT_ADD
{
  my($num,$tail,@textlist)=@_;

  foreach (@textlist)
  {
    if(length($_) >$num)
    {
      $_=join("",substr($_,0,$num),$tail);
    }
  }
  return @textlist;
}

##############################
#GET IP HOST
##############################

sub GET_IP_HOST
{
  my($ip)  =$ENV{'REMOTE_ADDR'};
  my($host)=gethostbyaddr(pack("C4",split('\.',$ip)),2);
  return ($ip,$host);
}

##############################
#OPEN DIRECTORY
##############################

sub OPEN_DIR
{
  my($address)=$_[0];
  my(@return);
  if(-d $address)
  {
    if(opendir(DIR,$address))
    {
      @return=readdir(DIR);
    }else
    {
      $return[0]='DIRECTORY_OPEN_ERROR';
    }
    closedir(DIR);
  }else
  {
    $return[0]='NO_DIRECTORY';
  }
  return @return;
}

##############################
#OPEN FILE
##############################

sub OPEN_FILE
{
  my($file)=@_;
  my(@ret);
  open(READ,"<$file")||warn $ret="Open Error $file";
  @ret=<READ>;
  close(READ);
  return @ret;
}

sub OPEN_BIN_FILE
{
  my($file)=@_;
  my(@ret);
  if(-f $file)
  {
    open(READ,"<$file")||warn $ret="Open Error $file";
    binmode(READ);
    while(<READ>){$ret[0].=$_;}
    close(READ);
    return @ret;
  }
  return 0;
}

##############################
#GET FILE LIST
##############################

sub GET_FILE_LIST
{
  my($type,$address)=@_;
  my @directory;
  my @return;
  @directory=&hutool::OPEN_DIR($address);

  if(@directory)
  {
    if($type==4||$type=~/(file)/i)
    {
      foreach(@directory)
      {
        my($filename)=join("/",$address,$_);
        if(-f $filename){push(@return,$_);}
      }
    }elsif($type==3||$type=~/(directory)/i)
    {
      foreach(@directory)
      {
        my($dirname)=join("/",$address,$_);
        if(-d $dirname && $_ ne "." && $_ ne".."){push(@return,$_);}
      }
    }elsif($type==2||$type=~/(alldirectory)/i)
    {
      foreach(@directory)
      {
        my($dirname)=join("/",$address,$_);
        if(-d $dirname){push(@return,$_);}
      }
    }elsif($type==1||$type=~/(filedirectory|directoryfile)/i)
    {
      foreach(@directory)
      {
        if($_ ne "." && $_ ne ".."){push(@return,$_);}
      }
    }else
    {#all
      @return=@directory;
    }
  }else{@return=@directory;}
  return @return;
}

sub PICKUP
{
  return $_[int(rand()*($#_+1))];
}

sub PICKUPS
{
  my($n,@array)=@_;
  my(@return);

  if($n*1>0)
  {
    if($#array+1<=$n*1)
    {
      @return=(0..$#array);
    }else
    {
      my($m);
      for($m=$n;$m>0;--$m)
      {
        my($num)=int(rand()*($#array+1));
        if(&hutool::COUNT_ELEMENT($num,@return)==0)
        {
          push(@return,$num);
        }else{++$m;}
      }
    }
  }

  foreach(@return){$_=$array[$_];}
  return @return;
}

sub COUNT_ELEMENT
{
  my($element,@array)=@_;
  my($count)=0;
  foreach(@array)
  {
    if($_ eq "$element"){++$count;}else{}
  }
  return $count;
}

sub READ_SETTING_VALUE
{#can read 'name = value'
  my($file)=@_;
  my @line;
  my $read=0;
  my %ret;

  if(-f $file){@line=&hutool::OPEN_FILE($file);}

  foreach(@line)
  {
    if(!($_=~/^(#|\/\/)+/) && $_=~/\=/)
    {
      $_=~/(?:\s)*([\w_]+)(?:\s)*=(?:\s)*([\w_\.\/]*)(?:\s)*/;
      $ret{$1}=$2;
    }
  }
  return %ret;
}

sub SORT_ARRAY
{
  my($type,@array)=@_;
  if($type eq "<")
  {
    @array=&hutool::SORT_ASCENDING(@array);
  }elsif($type eq ">")
  {
    @array=&hutool::SORT_DESCENDING(@array);
  }
  return @array;
}

sub SORT_ASCENDING
{
  return sort{$a<=>$b}(@_);
}

sub SORT_DESCENDING
{
  return reverse(&hutool::SORT_ASCENDING(@_));
}

sub PASS_JOIN
{
  my $div=shift(@_);
  my $ret=join($div,@_);
  $ret=~s/$div{2,}/$div/g;
  while($ret=~s/$div[\w\+%\$\.;:\&=\?!\*~\@\(\)\.]+$div\.\.$div/$div/){}
  while($ret=~s/$div\.$div/$div/){}
  return $ret;
}

sub DECODE_GET
{
  my(@names)=@_;
  my(%ret,$query,%ct);
  foreach(@names){$ret{$_}='';}#format
  $query=$ENV{'QUERY_STRING'};

  my @args=split(/&/, $query);
  foreach(@args)
  {
    my($name,$val)=split(/=/,$_,2);
    $val=~tr/+/ /;
    $val=~s/%([0-9a-fA-F][0-9a-fA-F])/pack('C', hex($1))/eg;
    if(exists($ret{$name})==0||$ret{$name} eq '')
    {
      $ret{$name}=$val;
    }else
    {
      if(($ret{$name}=~/^(ARRAY\(0x[0-9a-f]*\))$/)==0)
      {
        $ct{$name}=0;
        $ret{$name}=[$ret{$name}];
      }
      $ret{$name}[++$ct{$name}]=$val;
    }
  }
  return %ret;
}

sub DECODE_POST
{
  my(@names)=@_;
  my(%ret,$query,%ct);
  foreach(@names){$ret{$_}='';}#format
  read(STDIN,$query,$ENV{'CONTENT_LENGTH'});

  my @args=split(/&/, $query);
  foreach(@args)
  {
    my($name,$val)=split(/=/,$_,2);
    $val=~tr/+/ /;
    $val=~s/%([0-9a-fA-F][0-9a-fA-F])/pack('C', hex($1))/eg;
    if(exists($ret{$name})==0||$ret{$name} eq '')
    {
      $ret{$name}=$val;
    }else
    {
      if(($ret{$name}=~/^(ARRAY\(0x[0-9a-f]*\))$/)==0)
      {
        $ct{$name}=0;
        $ret{$name}=[$ret{$name}];
      }
      $ret{$name}[++$ct{$name}]=$val;
    }
  }
  return %ret;
}

sub ERROR
{
  my($code)=$_[0];#code 0xx maker error 1xx user error
  if($code==101)
  {
    $code='Argument Error.';
  }else
  {
    $code='Maker Error.';
  }
  return $code;
}

1;
